summaryrefslogtreecommitdiffstats
path: root/shell
diff options
context:
space:
mode:
authorstep <step-@users.noreply.github.com>2023-09-22 10:37:34 +0200
committerGitHub <noreply@github.com>2023-09-22 17:37:34 +0900
commit9f7684f6fe7a7889d1ebaded03b446c007d605ea (patch)
treee97901374da0d857b0eae3fe05d521adb8652ab5 /shell
parent2bed7d370e3ff654542aec0e9ad698dac64f244b (diff)
[bash] History, use perl if installed otherwise awk (#3313)
While awk is POSIX, perl isn't pre-installed on all *nix flavors. This commit eliminates the mandatory dependency on perl by using awk when perl is not available. Related: #3295, #3309, #3310. Test suite passed: * `make error` all test sections 'PASS' * `make docker-test` 215 runs, 1884 assertions, 0 failures, 0 errors, 0 skips. Manually tested in the following environments: * Linux amd64 with bash 3.2, 4.4, 5.2; gawk -P, one true awk, mawk, busybox awk. * macOS Catalina, bash 3.2, macOS awk 20070501. **Performance comparison:** Mawk turned out the fastest, then perl. One true awk's implementation should be the closest to macOS awk. Test data: 230 KB history, 15102 entries, including multi-line and duplicates. Linux, bash 4.4. Times in milliseconds. | Command | Mean | Min | Max | Relative | | :--- | ---: | ---: | ---: | -------: | | `mawk 1.3.4` | 22.9 | 22.3 | 25.6 | **1.00** | | `perl 5.26.1` | 34.3 | 33.6 | 35.1 | 1.49 | | `one true awk 20221215` | 41.9 | 40.6 | 46.3 | 1.83 | | `gawk 5.1.0` | 46.1 | 44.4 | 50.3 | 2.01 | | `busybox awk 1.27.0` | 64.8 | 63.2 | 70.0 | 2.82 | **Other Notes** A bug affects bash, which fails restoring a saved multi-line history entry as a single entry. Bug fixed in version 5.0.[^1] While developing this PR I discovered two unsubmitted issues affecting the current perl script. The output stream ends with `$'\n\0000'` instead of `$'\0000'`. Because of this, the script does not deduplicate a duplicated entry located at the end of the history list; therefore fzf displays two identical (not necessarily adjacent) entries. A minor point about the first issue is that the top fzf entry ends with a dangling line feed symbol, which is visible in the terminal. [^1]: https://github.com/bminor/bash/blob/ec8113b9861375e4e17b3307372569d429dec814/CHANGES#L1511 To enable: `shopt -s cmdhist lithist; HISTTIMEFORMAT='%F %T '`.
Diffstat (limited to 'shell')
-rw-r--r--shell/key-bindings.bash67
1 files changed, 50 insertions, 17 deletions
diff --git a/shell/key-bindings.bash b/shell/key-bindings.bash
index 98273b81..aa0b8ace 100644
--- a/shell/key-bindings.bash
+++ b/shell/key-bindings.bash
@@ -48,23 +48,56 @@ __fzf_cd__() {
dir=$(set +o pipefail; eval "$cmd" | FZF_DEFAULT_OPTS="$opts" $(__fzfcmd)) && printf 'builtin cd -- %q' "$dir"
}
-__fzf_history__() {
- local output opts script
- opts="--height ${FZF_TMUX_HEIGHT:-40%} --bind=ctrl-z:ignore ${FZF_DEFAULT_OPTS-} -n2..,.. --scheme=history --bind=ctrl-r:toggle-sort ${FZF_CTRL_R_OPTS-} +m --read0"
- script='BEGIN { getc; $/ = "\n\t"; $HISTCOUNT = $ENV{last_hist} + 1 } s/^[ *]//; print $HISTCOUNT - $. . "\t$_" if !$seen{$_}++'
- output=$(
- set +o pipefail
- builtin fc -lnr -2147483648 |
- last_hist=$(HISTTIMEFORMAT='' builtin history 1) perl -n -l0 -e "$script" |
- FZF_DEFAULT_OPTS="$opts" $(__fzfcmd) --query "$READLINE_LINE"
- ) || return
- READLINE_LINE=${output#*$'\t'}
- if [[ -z "$READLINE_POINT" ]]; then
- echo "$READLINE_LINE"
- else
- READLINE_POINT=0x7fffffff
- fi
-}
+if command -v perl > /dev/null; then
+ __fzf_history__() {
+ local output opts script
+ opts="--height ${FZF_TMUX_HEIGHT:-40%} --bind=ctrl-z:ignore ${FZF_DEFAULT_OPTS-} -n2..,.. --scheme=history --bind=ctrl-r:toggle-sort ${FZF_CTRL_R_OPTS-} +m --read0"
+ script='BEGIN { getc; $/ = "\n\t"; $HISTCOUNT = $ENV{last_hist} + 1 } s/^[ *]//; print $HISTCOUNT - $. . "\t$_" if !$seen{$_}++'
+ output=$(
+ set +o pipefail
+ builtin fc -lnr -2147483648 |
+ last_hist=$(HISTTIMEFORMAT='' builtin history 1) perl -n -l0 -e "$script" |
+ FZF_DEFAULT_OPTS="$opts" $(__fzfcmd) --query "$READLINE_LINE"
+ ) || return
+ READLINE_LINE=${output#*$'\t'}
+ if [[ -z "$READLINE_POINT" ]]; then
+ echo "$READLINE_LINE"
+ else
+ READLINE_POINT=0x7fffffff
+ fi
+ }
+else # awk
+ __fzf_history__() {
+ local output opts script
+ if [[ -z $__fzf_awk ]]; then
+ __fzf_awk=awk
+ # if installed, mawk is faster
+ command -v mawk > /dev/null &&
+ mawk --version | # at least 1.3.4
+ awk 'NR == 1 { split($2, a, "."); v=(a[1]*1000000+ a[2]*1000+ a[3]*1); exit !(v >= 1003004) }' &&
+ __fzf_awk=mawk
+ fi
+ opts="--height ${FZF_TMUX_HEIGHT:-40%} --bind=ctrl-z:ignore ${FZF_DEFAULT_OPTS-} -n2..,.. --scheme=history --bind=ctrl-r:toggle-sort ${FZF_CTRL_R_OPTS-} +m --read0"
+ [[ $(HISTTIMEFORMAT='' builtin history 1) =~ [[:digit:]]+ ]] # how many history entries
+ script='function P(b) { ++n; sub(/^[ *]/, "", b); if (!seen[b]++) { printf "%d\t%s%c", '$((BASH_REMATCH + 1))' - n, b, 0 } }
+ NR==1 { b = substr($0, 2); next }
+ /^\t/ { P(b); b = substr($0, 2); next }
+ { b = b RS $0 }
+ END { if (NR) P(b) }'
+ output=$(
+ set +o pipefail
+ builtin fc -lnr -2147483648 2> /dev/null | # ( $'\t '<lines>$'\n' )* ; <lines> ::= [^\n]* ( $'\n'<lines> )*
+ $__fzf_awk "$script" | # ( <counter>$'\t'<lines>$'\000' )*
+ FZF_DEFAULT_OPTS="$opts" $(__fzfcmd) --query "$READLINE_LINE"
+ ) || return
+ READLINE_LINE=${output#*$'\t'}
+ if [[ -z "$READLINE_POINT" ]]; then
+ echo "$READLINE_LINE"
+ else
+ READLINE_POINT=0x7fffffff
+ fi
+ }
+fi
# Required to refresh the prompt after fzf
bind -m emacs-standard '"\er": redraw-current-line'